Subject: [PATCH V3 1/3] vfio, platform: add support for ACPI while detecting the reset driver

From: [email-masked] (Arnd Bergmann)
Date: Tue, 29 Mar 2016 13:25:42 +0200

On Tuesday 29 March 2016 06:59:15 okaya at codeaurora.org wrote:
> On 2016-03-29 05:25, Arnd Bergmann wrote:
> > On Monday 28 March 2016 09:35:22 Sinan Kaya wrote:
> >> The code is using the compatible DT string to associate a reset driver 
> >> with
> >> the actual device itself. The compatible string does not exist on ACPI
> >> based systems. HID is the unique identifier for a device driver 
> >> instead.
> >> The change allows a driver to register with DT compatible string or 
> >> ACPI
> >> HID and then match the object with one of these conditions.
> >> 
> >> Rules for loading the reset driver are as follow:
> >> - ACPI HID needs match for ACPI systems
> >> - DT compat needs to match for OF systems
> >> 
> >> Tested-by: Eric Auger <[email-masked]> (device tree only)
> >> Tested-by: Shanker Donthineni <[email-masked]> (ACPI only)
> >> Signed-off-by: Sinan Kaya <[email-masked]>
> >> 
> > 
> > 
> > This really feels wrong for two reasons:
> > 
> > * device assignment of non-PCI devices is really special and doesn't
> >   seem to make sense on general purpose servers that would be the 
> > target
> >   for ACPI normally
> 
> 
> Why is it special? Acpi is not equal to pci. Platform devices are first 
> class devices too. Especially, _cls was introduced for this reason.

It still feels like a hack. The normal design for a server is to have
all internal devices show up on the PCI host bridge, next to the PCIe
ports, to have a simple way to manage any device, both internal and
off-chip. Putting a device on random MMIO registers outside of the
discoverable buses and have the firmware work around the lack of
discoverability will always be inferior.

> > 
> > * If there is indeed a requirement for ACPI to handle something like 
> > this,
> >   it should be part of the ACPI spec, with a well-defined method of 
> > handling
> >   reset, rather than having to add a device specific hack for each
> >   device separately.
> > 
> 
> I see. Normally, this is done by calling _rst method. AFAIK, Linux 
> doesn?t support _rst. I can check its presence and call it if it is 
> there.

Yes, that sounds reasonable: In patch 2 where you check for the
presence of the reset method, just keep the existing logic for
DT based systems, and use _rst on ACPI based systems instead,
then you can drop both patches 1 and 3.

	Arnd